var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('lodash'),
    isString = _require.isString;

var StyleCollector = function () {
  function StyleCollector() {
    _classCallCheck(this, StyleCollector);

    this.links = [];
  }

  _createClass(StyleCollector, [{
    key: 'ifEnter',
    value: function () {
      function ifEnter(component) {
        return component.defineStyle;
      }

      return ifEnter;
    }()
  }, {
    key: 'componentDidConstruct',
    value: function () {
      function componentDidConstruct(id, component, props) {
        var styleLink = component.defineStyle(props);
        if (isString(styleLink)) {
          this.links.push(styleLink);
        } else {
          var _links;

          // array of links
          (_links = this.links).push.apply(_links, _toConsumableArray(styleLink));
        }
      }

      return componentDidConstruct;
    }()
  }, {
    key: 'routeWillRender',
    value: function () {
      function routeWillRender() {
        this.links = [];
      }

      return routeWillRender;
    }()
  }, {
    key: 'appendToHead',
    value: function () {
      function appendToHead($head) {
        this.links.forEach(function (link) {
          return $head.append('<link rel="stylesheet" href="' + String(link) + '">');
        });
      }

      return appendToHead;
    }()
  }]);

  return StyleCollector;
}();

module.exports = StyleCollector;