var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('lodash'),
    isString = _require.isString;

var ScriptCollector = function () {
  function ScriptCollector() {
    _classCallCheck(this, ScriptCollector);

    this.scripts = [];
  }

  _createClass(ScriptCollector, [{
    key: 'ifEnter',
    value: function () {
      function ifEnter(component) {
        return component.defineScript;
      }

      return ifEnter;
    }()
  }, {
    key: 'componentDidConstruct',
    value: function () {
      function componentDidConstruct(id, component, props) {
        var script = component.defineScript(props);
        if (isString(script)) {
          this.scripts.push(script);
        } else {
          var _scripts;

          // array of scripts
          (_scripts = this.scripts).push.apply(_scripts, _toConsumableArray(script));
        }
      }

      return componentDidConstruct;
    }()
  }, {
    key: 'routeWillRender',
    value: function () {
      function routeWillRender() {
        this.scripts = [];
      }

      return routeWillRender;
    }()
  }, {
    key: 'appendToHead',
    value: function () {
      function appendToHead($head) {
        this.scripts.forEach(function (script) {
          return $head.append('<script src="' + String(script) + '"></script>');
        });
      }

      return appendToHead;
    }()
  }]);

  return ScriptCollector;
}();

module.exports = ScriptCollector;