Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = serverClientWebpackConfig;

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackNodeExternals = require('webpack-node-externals');

var _webpackNodeExternals2 = _interopRequireDefault(_webpackNodeExternals);

var _CONFIG = require('../CONFIG');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function serverClientWebpackConfig(_ref) {
  var dir = _ref.dir,
      shareConfig = _ref.shareConfig,
      corenConfig = _ref.corenConfig;

  var config = Object.assign({}, shareConfig, {
    entry: corenConfig.entry,
    target: 'node',
    output: {
      path: (0, _CONFIG.outputCommonJSDir)(dir),
      filename: '[name].commonjs2.js',
      libraryTarget: 'commonjs2'
    },
    externals: [(0, _webpackNodeExternals2['default'])(), /^(coren|\$)$/i].concat(_toConsumableArray(shareConfig.externals))
  });
  return (0, _webpack2['default'])(config);
}
module.exports = exports['default'];